float rayleigh_phase(float c){
    return (3.0 / (16.0 * pi)) * (1.0 + c * c);
}

float mie_phase(float c, float g){
    float gg = g * g;
    float cc = c * c;

    return (3.0 / (8.0 * pi) * (1.0 - gg) / (2.0 + gg)) * (1.0 + cc) / pow(1.0 + gg - 2.0 * g * c, 1.5);
}

float hg_phase(float c, float g){
    return ((1.0 - g * g) / pow(1.0 + g * g - 2.0 * g * c, 1.5)) / (4.0 * pi);
}

float clouds_phase(float c, float t){
    const float g = 0.25;
    const float m = 0.20;

    float phase0 = hg_phase(c, pow(g, t + 1.0));
    float phase1 = hg_phase(c, -pow(g, t + 1.0));

    return mix(phase0, phase1, m);
}