vec3 volumetric_shadow(vec3 position, vec3 shadow_position, bool water){
        shadow_settings s = pshadow();
        water_settings ws = swater();

        shadow_position = shadow_distortion(s, shadow_position) * 0.5 + 0.5;

        vec3 shadow = vec3(0.0);

        vec4 color0 = texture2(shadowcolor0, shadow_position.xy);
        vec4 color1 = texture2(shadowcolor1, shadow_position.xy);

        float ID = color1.w * 255.0;

        float depth0 = texture2(shadowtex0, shadow_position.xy).x;
        float depth1 = texture2(shadowtex1, shadow_position.xy).x;

        float shadow_depth0 = depth0 > shadow_position.z ? 1.0 : 0.0;
        float shadow_depth1 = depth1 > shadow_position.z ? 1.0 : 0.0;

        color0.xyz = srgb_to_linear(color0.xyz);
        color0.w = (1.0 - color0.w);

        if(water){
            float water_depth = (depth0 * 8.0 - 4.0) * shadowProjectionInverse[2].z + shadowProjectionInverse[3].z;
                  water_depth = (water_depth - trans_mad(shadowModelView, position).z);
            
            if(water_depth < 0.0) return vec3(1.0);

            #ifdef WATER_CAUSTICS
                float caustics = color1.z * 2.0 - 1.0;
                      caustics = pow(caustics * 8.0, WATER_CAUSTICS_STRENGTH);
            #else   
                float caustics = 1.0;
            #endif

            shadow += vec3(shadow_depth1);
            shadow *= exp2(-ws.attenuation_coefficient * ws.density * water_depth) * caustics;
        } else {
            #ifdef COLORED_SHADOW
                shadow += mix(vec3(shadow_depth0), color0.xyz * color0.w, saturate(shadow_depth1 - shadow_depth0));
            #else
                shadow += vec3(shadow_depth1);
            #endif    
        }

        return shadow * clouds_3D_shadow(position);
    }