#if defined SHADERS_VERTEX
    out vec2 coord;

    out mat3 skylight0;
    out mat3 skylight1;

    #include "/program/shaders1/common/indirect/skylight.glsl"

    void main(){
        coord = layout_texcoord.xy;

        gl_Position = vec4(coord * 2.0 - 1.0, 0.0, 1.0);

        vertex_skylight();
    }
#elif defined SHADERS_FRAGMENT
    in vec2 coord;

    in mat3 skylight0;
    in mat3 skylight1;

    #include "/program/shaders1/common/atmosphere/atmosphere.glsl"
    #include "/program/shaders1/common/specular/raytrace.glsl"
    #include "/program/shaders1/common/diffuse_light.glsl"

    void main(){
        gbuffers_data g = gbuffers(coord);
        space_position sp = position(coord, g.depth, false);
        materials m = material(g.depth, g.ID);

        vec4 noise = blue_noise(gl_FragCoord.xy);
        vec3 color = diffuse_light(g, sp, m, coord, g.albedo, g.normal, sp.view_position1, sp.position1, sp.inverse_position1, noise);

        buffers0 = encodeRGBE8(max0(color));

        /* RENDERTARGETS:0 */
    }
#endif